/*   Copyright (c)  29.07.2002  Carsten Bauer (Berlin)
 *
 *   header file for lite.c
 *
 *
 */
  

typedef struct {
     float   dir[3];   /* direction (intersection point normal) */
     float   val[3];   /* color value */
} LITEVAL;


typedef struct {
    short *indblock;     /* the subblock of the lite-octree */    
    LITEVAL *lvarr;      /* the liteval list of this subblock */
    short nlvs;          /* actual number of lvs */
    short maxlvs;        /* maximum number of lvs */
    char bldep;          /* blockdepth */
} LITEBLOCK;


#define   USEDC     01    /* activate direct caching */
#define   FILEWRT   02    /* store to file */
#define   SSAMPEXC  04    /* exclude ambient supersamples */

extern CUBE thescene;

extern float dccub;            /* max. resolution, defaults to 0.05 m */
extern short dcsubd;             /* depth of the blocks, defaults to 3*/
extern float dconv;            /* conv. for storage optimazation */
extern float dcrlen;           /* min. ray length for DC usage */      
extern char dcaccur;           /* accuracy switch for DC usage, defaults to 'n' */
extern float dcssampexc;       /* exclude/include amb. supersamples, defaults to 0.0 */
extern float dcnormdev;        /* allowed normal deviation, defaults to 90 degrees */
extern float dcthresh[3];      /* threshholds for self adapting */
extern char dctval;             /* number of testvals for self adapting, defaults to 3 */
extern short dctrig;
extern short liflags;

short shifti, modi;
int aloc[] ={1, 8, 64, 512, 4096, 32768, 262144, 2097152,
                         16777216, 134217728, 1073741824};
int redaloc;
short maxalv=10;             
double minrlen;

short dcmaxdep;
short dcbld;
LITEBLOCK **liblkptr;

int LITEVALSIZ = sizeof(LITEVAL);

#define LVSBUFSZ  200
FILE* lvstream;
char* lvsfbuf;  /* the write buffer */
int lvbufbsz;

#ifdef INFO
unsigned int setlvs = 0;
unsigned int usedlvs = 0;
unsigned int totmem = 0;
unsigned int blockalc = 0;
unsigned int blocksrealc = 0;
int maxref = 0;
#endif
